<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="indexpage" kind="group">
    <compoundname>index</compoundname>
    <title>Cypress PSoC 6 Bluetooth Low Energy Middleware Library 3.50</title>
    <detaileddescription>
<para>The Bluetooth Low Energy (BLE) middleware contains a comprehensive API to configure the BLE Stack and the underlying chip hardware.</para><para>The standalone BT Configurator is shipped in ModusToolbox to make it easy to configure PSoC 6 BLE Middleware.</para><para>Include cy_ble_common.h and cy_ble_event_handler.h to get access to all functions and other declarations in this library. If you are using the ModusToolbox BT Configurator, you can include cycfg_ble.h only.</para><para>The PSoC 6 BLE Middleware incorporates a Bluetooth Core Specification v5.0 compliant protocol stack. You may access the GAP, GATT and L2CAP layers of the stack using the API.</para><para>The API are broadly categorized as follows:<itemizedlist>
<listitem><para><ref kindref="compound" refid="group__group__ble__common__api">BLE Common API</ref></para></listitem><listitem><para><ref kindref="compound" refid="group__group__ble__service__api">BLE Service-Specific API</ref></para></listitem></itemizedlist>
</para><para><bold>Features:</bold><itemizedlist>
<listitem><para>Multi-link supports for up to four simultaneous connections in any combination of roles</para></listitem><listitem><para>Bluetooth v5.0 compliant protocol stack<itemizedlist>
<listitem><para>LE 2 Mbps</para></listitem></itemizedlist>
</para></listitem><listitem><para>Generic Access Profile (GAP) features<itemizedlist>
<listitem><para>Broadcaster, Observer, Peripheral and Central roles</para></listitem><listitem><para>User-defined advertising data</para></listitem><listitem><para>Bonding support for up to 128 devices</para></listitem><listitem><para>Security modes 1 and 2</para></listitem></itemizedlist>
</para></listitem><listitem><para>Generic Attribute Profile (GATT) features<itemizedlist>
<listitem><para>GATT Client and Server</para></listitem><listitem><para>16-, 32-, and 128-bit UUIDs</para></listitem></itemizedlist>
</para></listitem><listitem><para>Special Interest Group (SIG) adopted GATT-based Profiles and Services, and quick prototype of new profile design through intuitive BT Configurator Custom Profile development;</para></listitem><listitem><para>Security Manager features<itemizedlist>
<listitem><para>Pairing methods: Just works, Passkey Entry, Out of Band, Numeric Comparison (LE Secure connections)</para></listitem><listitem><para>Authenticated man-in-the-middle (MITM) protection and data signing</para></listitem></itemizedlist>
</para></listitem><listitem><para>Logical Link Control and Adaption Protocol (L2CAP) connection-oriented channel</para></listitem><listitem><para>Link Layer (LL) features<itemizedlist>
<listitem><para>Master and Slave roles</para></listitem><listitem><para>128-bit AES encryption</para></listitem><listitem><para>Low Duty Cycle Advertising</para></listitem><listitem><para>LE Ping</para></listitem><listitem><para>Privacy 1.2</para></listitem><listitem><para>Data length extension (DLE)</para></listitem></itemizedlist>
</para></listitem></itemizedlist>
</para>
<para><heading level="1">When to use the BLE</heading></para>
<para>BLE is used in very low-power network and Internet of Things (IoT) solutions using low-cost battery operated devices that can quickly connect and form simple wireless links. Target applications include HID, remote controls, sports and fitness monitors, portable medical devices and smart phone accessories, among many others.</para>

<para><heading level="1">SIG adopted Profiles and Services</heading></para>
<para>The BLE resource supports numerous SIG-adopted GATT-based Profiles and Services. Each of these can be configured for either a GATT Client or GATT Server. It generates all the necessary code for a particular Profile/Service operation, as configured in the BLE Configurator.</para>

<para><heading level="1">Custom Profiles</heading></para>
<para>You can create custom Profiles that use existing Services, and you can create custom Services with custom Characteristics and Descriptors.</para>

<para><heading level="1">Debug Support</heading></para>
<para>For testing and debugging, the PSoC 6 BLE Middleware can be configured to use Host Controller Interface (HCI) mode through a UART. Refer to Initialize and Enable PSoC 6 BLE Middleware in Controller-only Mode (HCI over Software API).</para><para>For over-the-air verification, the Cypress CySmart Central Emulation Tool can be used for generic Bluetooth host stack emulation.</para>

<para><heading level="1">PSoC 6 BLE Middleware Architecture</heading></para>
<para> </para><para>PSoC 6 BLE Middleware consists of the BLE Stack, BLE Profile, Hardware Abstraction Layer (HAL), and the Link Layer. The following figure shows the high-level architecture of the PSoC 6 BLE Middleware, illustrating the relationship between each of the layers and how the application interacts with the PSoC 6 BLE Middleware. Note that the application uses callback functions to handle BLE events, which you can use to build your state machine.</para><para>The following block diagram shows the architecture of PSoC 6 BLE Middleware under Complete BLE Protocol mode. <image name="ble_architecture_single_cpu_mode.png" type="html" />
</para><para>The following block diagram shows the architecture of PSoC 6 BLE Middleware under Controller Only mode (HCI over Software API). <image name="ble_architecture_hci_mode.png" type="html" />
</para><para>The following sub-sections give an overview of each of these layers.</para>
<para><bold>BLE Stack</bold></para>
<para /><para>The BLE stack implements the core BLE functionality as defined in Bluetooth Core Specification 5.0. The stack is included as a pre-compiled library in the PSoC 6 BLE Middleware library. The BLE Stack implements the layered architecture of the BLE protocol stack as shown in the following figure.</para><para><image name="ble_stack.png" type="html" />
</para>
<para><bold>Generic Access Profile (GAP)</bold></para>
<para>The Generic Access Profile defines the procedures related to discovery of Bluetooth devices and the link- management aspects of connecting to Bluetooth devices. In addition, this profile includes common format requirements for parameters accessible on the user interface level.</para><para>The Generic Access Profile defines the following roles when operating over the LE physical channel:<itemizedlist>
<listitem><para><bold>Broadcaster role</bold>: A device operating in the Broadcaster role can send advertising events. It is referred to as a Broadcaster. It has a transmitter and may have a receiver.</para></listitem><listitem><para><bold>Observer role</bold>: A device operating in the Observer role is a device that receives advertising events. It is referred to as an Observer. It has a receiver and may have a transmitter.</para></listitem><listitem><para><bold>Peripheral role</bold>: A device that accepts an LE physical link using any of the connection establishment procedures is said to have a Peripheral role. A device operating in the Peripheral role will be in the "Slave role" in the Link Layer Connection State. A device operating in the Peripheral role is referred to as a Peripheral. A Peripheral has both a transmitter and a receiver.</para></listitem><listitem><para><bold>Central role</bold>: A device that supports the Central role initiates the establishment of a physical connection. A device operating in the "Central role" will be in the "Master role" in the Link Layer Connection. A device operating in the Central role is referred to as a Central. A Central has a transmitter and a receiver.</para></listitem></itemizedlist>
</para>

<para><bold>Generic Attribute Profile (GATT)</bold></para>
<para>The Generic Attribute Profile defines a generic service framework using the ATT protocol layer. This framework defines the procedures and formats of services and their characteristics. It defines the procedures for Service, Characteristic, and Descriptor discovery, reading, writing, notifying, and indicating Characteristics, as well as configuring the broadcast of Characteristics. GATT roles are:</para><para><itemizedlist>
<listitem><para><bold>GATT Client</bold>: This is the device that wants data. It initiates commands and requests to the GATT Server. It can receive responses, indications, and notifications data sent by the GATT Server.</para></listitem><listitem><para><bold>GATT Server</bold>: This is the device that has the data and accepts incoming commands and requests from the GATT Client. It sends responses, indications, and notifications to a GATT Client. The BLE Stack can support both roles simultaneously.</para></listitem></itemizedlist>
</para>

<para><bold>Attribute Protocol (ATT)</bold></para>
<para>The Attribute Protocol layer defines a Client/Server architecture above the BLE logical transport channel. The attribute protocol allows a device referred to as the GATT Server to expose a set of attributes and their associated values to a peer device referred to as the GATT Client. Attributes exposed by the GATT Server can be discovered, read, and written by a GATT Client, and can be indicated and notified by the GATT Server. All the transactions on attributes are atomic.</para>

<para><bold>Security Manager Protocol (SMP)</bold></para>
<para>The Security Manager Protocol defines the procedures and behavior to manage pairing, authentication, and encryption between the devices. These include:<itemizedlist>
<listitem><para>Encryption and Authentication</para></listitem><listitem><para>Pairing and Bonding<itemizedlist>
<listitem><para>Pass Key and Out of Band bonding</para></listitem></itemizedlist>
</para></listitem><listitem><para>Key Generation for a device identity resolution, data signing, and encryption</para></listitem><listitem><para>Pairing method selection based on the IO capability of the GAP central and GAP peripheral device.</para></listitem></itemizedlist>
</para>

<para><bold>Logical Link Control Adaptation Protocol (L2CAP)</bold></para>
<para>L2CAP provides a connectionless data channel. LE L2CAP provides the following features:<itemizedlist>
<listitem><para>Channel multiplexing, which manages three fixed channels. Two channels are dedicated for higher protocol layers like ATT, SMP. One channel is used by the LE-L2CAP protocol signalling channel for its own use.</para></listitem><listitem><para>Segmentation and reassembly of packets whose size is up to the BLE Controller managed maximum packet size.</para></listitem><listitem><para>Connection-oriented channel over a specific application registered using the PSM (protocol service multiplexer) channel. It implements credit-based flow control between two LE L2CAP entities. This feature can be used for BLE applications that require transferring large chunks of data.</para></listitem></itemizedlist>
</para>

<para><bold>Host Controller Interface (HCI)</bold></para>
<para>The HCI layer implements a command, event, and data interface to allow link layer access from upper layers such as GAP, L2CAP, and SMP.</para>

<para><bold>Link Layer (LL)</bold></para>
<para>The Link Layer implements a command, event, and data interface to allow link layer access from upper layers such as GAP, L2CAP, and SMP. The LL protocol manages the physical BLE connections between devices. It supports all LL states such as Advertising, Scanning, Initiating, and Connecting (Master and Slave). It implements all the key link control procedures such as LE Encryption, LE Connection Update, LE Channel Update, and LE Ping.</para><para>The Link Layer is a hardware-firmware co-implementation, where the key time critical LL functions are implemented in the LL hardware. The LL firmware maintains and controls the key LL procedure state machines. It supports all the BLE chip-specific low-power modes. The BLE Stack is a pre-compiled library. The appropriate configuration of the BLE Stack library is linked during a build process based on the application. The BLE Stack libraries are Arm Embedded Application Binary Interface (EABI) compliant and are compiled using Arm compiler version 5.03.</para>


<para><bold>Profile Layer</bold></para>
<para /><para>In BLE, data is organized into concepts called Profiles, Services, and Characteristics.</para><para><itemizedlist>
<listitem><para>A <bold>Profile</bold> describes how devices connect to each other to find and use Services. The Profile describes the type of application and the general expected behavior of that device. See the <bold>Parameter Configuration</bold> section of ModusToolbox Bluetooth Configurator Guide for configuring the PSoC 6 BLE Middleware.</para></listitem><listitem><para>A <bold>Service</bold> is a collection of data entities called Characteristics. A Service is used to define a certain function in a Profile. A Service may also define its relationship to other Services. A Service is assigned a Universally Unique Identifier (UUID). This is 16 bits for SIG adopted Services and 128 bits for custom Services. See the <bold>GATT Settings Tab</bold> section of ModusToolbox Bluetooth Configurator Guide for information about adding Services to a Profile.</para></listitem><listitem><para>A <bold>Characteristic</bold> contains a Value and the Descriptor that describes a Characteristic Value. It is an attribute type for a specific piece of information within a Service. Like a Service, each Characteristic is designated with a UUID; 16 bits for SIG adopted Characteristics and 128 bits for custom Characteristics. See the <bold>GATT Settings Tab</bold> section of ModusToolbox Bluetooth Configurator Guide for information about adding Characteristics and Descriptors. The following diagram shows the relationship between Profiles, Services, and Characteristics in a sample BLE heart rate monitor application using a Heart Rate Profile.</para></listitem></itemizedlist>
</para><para><image name="ble_profiles.png" type="html" />
</para><para>The Heart Rate Profile contains a Heart Rate Service and a Device Information Service. Within the Heart Rate Service, there are three Characteristics, each containing different information. The device in the diagram is configured in the Sensor role, meaning that in the context of the Heart Rate Profile, the device is a GAP Peripheral and a GATT Server. These concepts are explained in the <ref kindref="member" refid="page_ble_general_1group_ble_stack">BLE Stack</ref> description.</para><para>The Profile layer is provided by PSoC 6 BLE Middleware using the parameter configurations specified in the Bluetooth Configurator. The Profile implements the Profile-specific attribute database and functions required for the application. You can choose to configure the standard SIG adopted Profile and generate a design, or define a Custom Profile required by an application.</para>

<para><bold>Hardware Abstraction Layer (HAL)</bold></para>
<para>The HAL implements the interface between the BLE stack and the underlying hardware. This layer is meant for the stack only and it is not advisable to modify it. </para>


<para><heading level="1">PSoC 6 BLE Middleware Changes</heading></para>
<para>This section lists changes made to the PSoC 6 BLE Middleware.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;&lt;b&gt;Version&lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;&lt;b&gt;Changes&lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;&lt;b&gt;Reason for Change&lt;/b&gt;&lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="7"&gt;&lt;p&gt;3.50 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated PILO part of BLESS MW HAL to be compatible with psoc6pdl 1.6.1.&lt;br /&gt;&lt;br /&gt; Refer to section &lt;a href="#page_ble_section_more_information_1group_ble_lfclk_Pilo_conf"&gt;Configuring PILO for BLESS Deep Sleep Mode&lt;/a&gt; for details about the requirements for using the PILO as the LF clock source. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;To support PILO on the PSoC 64 Secure device.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added BLE Stack controller libraries with IPC communication (BLESS_CONTROLLER_IPC) for CM0+. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Enable users to build their own CM0+ image with a BLE controller to operate in BLE Dual CPU mode.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the procedure of processing the CY_BLE_EVT_GATTS_WRITE_REQ event: an error response (with reason INVALID_HANDLE) is sent, if the handle was processed neither by registered services nor an application BLE callback. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Improved the handling of the CY_BLE_EVT_GATTS_WRITE_REQ event to allow operation with a custom GATT database.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the CY_BLE_SFLASH_DIE_xxx macros (in cy_ble_gap.h) according to the PSoC 6 BLE production configuration. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The silicon-generated "Company assigned" part of the device address has a high repetition rate of the generated MAC address. &lt;verbatim&gt;embed:rst .. raw:: html  &amp;lt;div class="admonition note"&amp;gt;&amp;lt;p class="admonition-title"&amp;gt;note&amp;lt;/p&amp;gt;&amp;lt;p&amp;gt;&amp;lt;p&amp;gt;The silicon-generated "Company assigned" option does not guarantee a unique device address. For mass production, Cypress strongly suggests that the device address be programmed into the user area (Row 0) of the Sflash location via the SWD interface. Refer to section "Public device address" of &amp;lt;a href="https://www.cypress.com/ModusToolboxBLEConfig"&amp;gt;ModusToolbox BT Configurator Guide&amp;lt;/a&amp;gt; for details  &amp;lt;/p&amp;gt;&amp;lt;/p&amp;gt;&amp;lt;/div&amp;gt;&lt;/verbatim&gt;&lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added preprocessor expression to verify count of GATT database entries. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;BLE Stack supports maximum 512 entries of GATT database.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Documentation updates. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Changed the code snippet for initial PILO trimming and updating the trim step-size in section &lt;a href="#page_ble_section_more_information_1group_ble_lfclk_Pilo_conf"&gt;Configuring PILO for BLESS Deep Sleep Mode&lt;/a&gt;. &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the BLE Stack to version 5.0.8.220. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Refer to &lt;a href="#page_group_ble_changelog_1section_group_ble_changelog_BLE_Stack_Changes"&gt;BLE Stack Changes&lt;/a&gt;. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="3"&gt;&lt;p&gt;3.40 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added BLE Stack libraries for CM0+ core.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Support BLE CM0+ Single CPU mode.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the procedure of processing events to wait 10 ms on CY_BLE_EVT_SOFT_RESET_COMPLETE events. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Ensure that the controller is completely reset before generating the event to the application. Refer to CY_BLE_EVT_SOFT_RESET_COMPLETE event documentation.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the BLE Stack to version 5.0.7.196 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Refer to &lt;a href="#page_group_ble_changelog_1section_group_ble_changelog_BLE_Stack_Changes"&gt;BLE Stack Changes&lt;/a&gt;. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="4"&gt;&lt;p&gt;3.30 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated the procedure of processing events to clear the cy_ble_pair_Status flags on CY_BLE_EVT_STACK_SHUTDOWN_COMPLETE and CY_BLE_EVT_SOFT_RESET_COMPLETE events. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;&lt;a href="group__group__ble__common__api__functions.html#group__group__ble__common__api__functions_1gaf33761a3b24ccf96b4b659b251ef19f0"&gt;Cy_BLE_IsDevicePaired()&lt;/a&gt; falsely returned True prior to authentication after a radio reset.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Fixed the setting of a device address in handling the CY_BLE_EVT_STACK_ON event, if the BLE middleware is configured to operate only in the Broadcaster GAP role. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;With the BLE configured only as a broadcaster, the configuration for a BD address in the BLE customizer was not effective.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Documentation updates. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation update and clarification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the BLE Stack to version 5.0.6.161. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Refer to &lt;a href="#page_group_ble_changelog_1section_group_ble_changelog_BLE_Stack_Changes"&gt;BLE Stack Changes&lt;/a&gt;. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="6"&gt;&lt;p&gt;3.20 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added support ARM Compiler 6.&lt;br /&gt; The BLE libraries are built with the following options to be compatible with ModusToolbox:&lt;br /&gt; -fshort-enums - set the size of an enumeration type to the smallest data type that can hold all enumerator values&lt;br /&gt; -fshort-wchar - Set the size of wchar_t to 2 bytes&lt;br /&gt; o operate in custom environments with ARM Compiler 6, apply the above mentioned build options. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Support Arm Compiler 6.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added support for BLE dual CPU mode with pre-compiled CM0 image. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Pre-compiled application images executed on Cortex M0+ core of the PSoC 6 dual-core MCU. The images are provided as C arrays ready to be compiled as part of the Cortex M4 application. The Cortex M0+ application code is placed to internal flash by the Cortex M4 linker script. CM0P_BLESS image is used for BLE dual CPU mode.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Fixed CY_BLE_ENABLE_PHY_UPDATE macros for enable "LE 2 Mbps" feature. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;"Enable LE 2 Mbps" feature does not work if it selects in BT Configurator.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;The PSoC 6 BLE Middleware is re-organized for supporting MT2.0 make flow. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Support new make flow. Refer to section &lt;a href="page_ble_section_configuration_considerations.html#"&gt;Configuration Considerations&lt;/a&gt; for details.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Disable support HCI over UART in PSoC 6 BLE Middleware side. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The SoC mode library was split into three libraries: host, controller and stack manager. The new organization structure allows usage of the same controller library with BLESS host, a UART application or any third party host, over a software HCI interface.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the BLE Stack to version 5.0.5.110. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Refer to &lt;a href="#page_group_ble_changelog_1section_group_ble_changelog_BLE_Stack_Changes"&gt;BLE Stack Changes&lt;/a&gt;. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="4"&gt;&lt;p&gt;3.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Disabled support BLE dual CPU mode. The following Software components are no longer supported:&lt;ul&gt;&lt;li&gt;&lt;p&gt;BLE dual CPU mode, controller on CM0+ only, Soft FP prebuilt library,&lt;br /&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;BLE dual CPU mode, host on CM4 only, Soft FP prebuilt library,&lt;br /&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;BLE dual CPU mode, host on CM4 only, Hard FP prebuilt library.&lt;br /&gt;  &lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Refer to ModusToolbox 1.1 Release Notes.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added the new SW component "BLE OTA with code sharing, Profile only". Updated documentation. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Enable the PSoC 6 BLE Middleware to support OTA with code sharing.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Fixed the Cy_BLE_HAL_BlessStart() function of the PSoC 6 BLE Middleware: removed the BLE ECO reset before BLESS initialization. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Fix ModusToolbox 1.0 errata.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the BLE Stack to version 5.0.4.946. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Refer to &lt;a href="#page_group_ble_changelog_1section_group_ble_changelog_BLE_Stack_Changes"&gt;BLE Stack Changes&lt;/a&gt;. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="6"&gt;&lt;p&gt;3.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The PSoC 6 BLE Middleware is re-organized, so that it can be built as a device agnostic immutable library. &lt;br /&gt;&lt;ul&gt;&lt;li&gt;&lt;p&gt;The BLE configure structure and BLE service configure structures were updated.&lt;br /&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Changed the configuration flow. Refer to section &lt;a href="page_ble_section_configuration_considerations.html#"&gt;Configuration Considerations&lt;/a&gt; to configuration details.&lt;br /&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Added the following functions:&lt;br /&gt; &lt;a href="group__group__ble__common__api__functions.html#group__group__ble__common__api__functions_1ga3d3e2bf00cc87f8dfc17fa0c68fd7506"&gt;Cy_BLE_RegisterEventCallback()&lt;/a&gt;,&lt;br /&gt; &lt;a href="group__group__ble__common__api__functions.html#group__group__ble__common__api__functions_1ga11dd55190fcf99efcc2dd0f625014f4b"&gt;Cy_BLE_EnableLowPowerMode()&lt;/a&gt;&lt;br /&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Changed BLE Interrupt Notification Callback feature interface:&lt;br /&gt; added &lt;a href="group__group__ble__common___intr__feature__api__functions.html#group__group__ble__common___intr__feature__api__functions_1ga2431c8315bbb2d7dee6709c6b0af65be"&gt;Cy_BLE_ConfigureIpcForInterruptCallback()&lt;/a&gt; &lt;br /&gt; added &lt;a href="group__group__ble__common___intr__feature__api__functions.html#group__group__ble__common___intr__feature__api__functions_1ga39785f5666e0ffad99d2d8327cdd669b"&gt;Cy_BLE_IntrNotifyIsrHandler()&lt;/a&gt; &lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Enable the PSoC 6 BLE Middleware to be built as a device agnostic immutable library.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the RAM memory calculation (macros CY_BLE_GATT_MTU_BUFF_COUNT) &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Decreased the RAM usage by PSoC 6 BLE Middleware   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Decreased the ACT_LDO startup time from 4 to 10. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Support for the 10uF capacitor on VDCDC.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the config structures &lt;a href="structcy__stc__ble__config__t.html#"&gt;cy_stc_ble_config_t&lt;/a&gt;. Added the pointer to the configuration parameter structure for the Radio PA calibration (field paCalConfig). &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Enabling the user to override the BLE radio's default TX power configurations.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Documentation updates.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation update and clarification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the BLE Stack to version 5.0.3.935. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Refer to &lt;a href="#page_group_ble_changelog_1section_group_ble_changelog_BLE_Stack_Changes"&gt;BLE Stack Changes&lt;/a&gt;. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="6"&gt;&lt;p&gt;2.20 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added support for PILO.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;PSoC 6 BLE supports Precision ILO (PILO) which can be used as an LF clock source. Refer to &lt;a href="#page_ble_section_more_information_1group_ble_lfclk_conf"&gt;LFCLK Configuration for BLESS Deep Sleep Mode&lt;/a&gt; for more details.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the &lt;a href="group__group__ble__common__api__functions.html#group__group__ble__common__api__functions_1ga1590f7ff12022997c336b8a271d3802e"&gt;Cy_BLE_RegisterAppHostCallback()&lt;/a&gt; functionality. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added support for BLE single CPU mode.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated Write Request events handler in PSoC 6 BLE Middleware. Return CY_BLE_GATT_ERR_INVALID_HANDLE if the attribute handle is out of database range.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Handling invalid range of attribute handle during Write Request event.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated flash memory calculation for Bonded device list  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The function Cy_BLE_StackInit() returned CY_BLE_ERROR_INVALID_PARAMETER when the Resolving list parameter is set to 1.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Documentation updates.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation update and clarification. Removed the Errata section.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the BLE Stack to version 5.0.2.917. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Refer to &lt;a href="#page_group_ble_changelog_1section_group_ble_changelog_BLE_Stack_Changes"&gt;BLE Stack Changes&lt;/a&gt;. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;2.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added return value CY_BLE_ERROR_FLASH_WRITE_NOT_PERMITED for following functions: &lt;a href="group__group__ble__common__api__functions.html#group__group__ble__common__api__functions_1gae34ba6a9039ee7e8f7b406b1ea0f1cf0"&gt;Cy_BLE_StoreAppData()&lt;/a&gt;&lt;br /&gt;&lt;a href="group__group__ble__common__api__functions.html#group__group__ble__common__api__functions_1ga778852ddcd6a37606668984aca7c3754"&gt;Cy_BLE_StoreBondingData()&lt;/a&gt;&lt;br /&gt; Added assertion in Cy_BLE_HAL_NvramWrite() to catch failure (CY_SYSPM_INVALID_STATE) during increasing core voltage from 0.9V to 1.1V for flash operation.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Flash operation is not permitted with protection context (PC) value &amp;gt; 0 and core voltage 0.9V, because of a preproduction hardware limitation.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Documentation updates.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation update and clarification.  &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="5"&gt;&lt;p&gt;2.0&lt;br /&gt; Production &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added the BLE user configuration file cy_ble_config.h.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;To make the BLE configuration more flexible. Allows redefining the configuration define(s) generated by the BLE customizer and default BLE clock defines (from cy_ble_clk.h).   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the BLE Interrupt Notification Feature.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added support for BLE dual CPU mode.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the &lt;a href="group__group__ble__common__api__gatt__server__functions.html#group__group__ble__common__api__gatt__server__functions_1ga27fc940942188f1bb26364ab21a77bed"&gt;Cy_BLE_GATTS_ReadAttributeValueLocal()&lt;/a&gt; and &lt;a href="group__group__ble__common__api__gatt__server__functions.html#group__group__ble__common__api__gatt__server__functions_1ga6297d202cdac41fb65d63fd57f8c529c"&gt;Cy_BLE_GATTS_ReadAttributeValuePeer()&lt;/a&gt; functions.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Those functions have the wrong Locally/Peer initiate operation flag.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;The following defined values for the CY_BLE_STACK_MODE configuration parameter were deprecated:&lt;br /&gt; CY_BLE_STACK_HOST_ONLY&lt;br /&gt; CY_BLE_STACK_HOST_CONTR_UART&lt;br /&gt; CY_BLE_STACK_HOST_IPC.&lt;br /&gt; The following defined values were renamed:&lt;br /&gt; CY_BLE_STACK_DEBUG to CY_BLE_STACK_MODE_SINGLE_SOC &lt;br /&gt; CY_BLE_STACK_RELEASE to CY_BLE_STACK_MODE_DUAL_IPC.&lt;br /&gt;  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Deprecated not supported (debug) modes.&lt;br /&gt; The defines CY_BLE_CONFIG_STACK_DEBUG and CY_BLE_CONFIG_STACK_RELEASE were renamed to have more meaningful name.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;The BLE Stack was updated to version 5.0.0.898.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Refer to &lt;a href="#page_group_ble_changelog_1section_group_ble_changelog_BLE_Stack_Changes"&gt;BLE Stack Changes&lt;/a&gt;. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;2.0&lt;br /&gt; BETA#2 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added new API: &lt;br /&gt; &lt;a href="group__group__ble__common__api__functions.html#group__group__ble__common__api__functions_1gaf33761a3b24ccf96b4b659b251ef19f0"&gt;Cy_BLE_IsDevicePaired()&lt;/a&gt;,&lt;br /&gt; &lt;a href="group__group__ble__common__api__functions.html#group__group__ble__common__api__functions_1gabc74705f034cd89fa8de16e93e223119"&gt;Cy_BLE_GetDeviceRole()&lt;/a&gt;,&lt;br /&gt; &lt;a href="group__group__ble__common__api__functions.html#group__group__ble__common__api__functions_1ga5021cf50fca185598f86aee60e276f73"&gt;Cy_BLE_IsPeerConnected()&lt;/a&gt;,&lt;br /&gt; &lt;a href="group__group__ble__common__api__gatt__server__functions.html#group__group__ble__common__api__gatt__server__functions_1ga83833a69e752df584bf934e657269b6b"&gt;Cy_BLE_GATTS_WriteAttributeValuePeer()&lt;/a&gt;,&lt;br /&gt; &lt;a href="group__group__ble__common__api__gatt__server__functions.html#group__group__ble__common__api__gatt__server__functions_1ga95db4f1380702b6b24efeef544cb1502"&gt;Cy_BLE_GATTS_WriteAttributeValueLocal()&lt;/a&gt;,&lt;br /&gt; &lt;a href="group__group__ble__common__api__gatt__server__functions.html#group__group__ble__common__api__gatt__server__functions_1ga6297d202cdac41fb65d63fd57f8c529c"&gt;Cy_BLE_GATTS_ReadAttributeValuePeer()&lt;/a&gt;,&lt;br /&gt; &lt;a href="group__group__ble__common__api__gatt__server__functions.html#group__group__ble__common__api__gatt__server__functions_1ga27fc940942188f1bb26364ab21a77bed"&gt;Cy_BLE_GATTS_ReadAttributeValueLocal()&lt;/a&gt;,&lt;br /&gt; &lt;a href="group__group__ble__common__api__gatt__server__functions.html#group__group__ble__common__api__gatt__server__functions_1ga5637f7d1c98396861fa5473aaa0e4935"&gt;Cy_BLE_GATTS_IsIndicationEnabled()&lt;/a&gt;,&lt;br /&gt; &lt;a href="group__group__ble__common__api__gatt__server__functions.html#group__group__ble__common__api__gatt__server__functions_1ga8f9c0c5d189db93aa25f9368059f1672"&gt;Cy_BLE_GATTS_SendIndication()&lt;/a&gt;,&lt;br /&gt; &lt;a href="group__group__ble__common__api__gatt__server__functions.html#group__group__ble__common__api__gatt__server__functions_1gac49f73eea18ed60ffc71ff218f664ae7"&gt;Cy_BLE_GATTS_IsNotificationEnabled()&lt;/a&gt;,&lt;br /&gt; &lt;a href="group__group__ble__common__api__gatt__server__functions.html#group__group__ble__common__api__gatt__server__functions_1gaf52c8c5d584562649b4c02bdb4673790"&gt;Cy_BLE_GATTS_SendNotification()&lt;/a&gt;,&lt;br /&gt; &lt;a href="group__group__ble__common__api__gatt__server__functions.html#group__group__ble__common__api__gatt__server__functions_1ga144da11ae3b06cec1d3d52b669ce7882"&gt;Cy_BLE_GATTS_SendErrorRsp()&lt;/a&gt;,&lt;br /&gt; &lt;a href="group__group__ble__common__api__gatt__client__functions.html#group__group__ble__common__api__gatt__client__functions_1gaba9c39370753dfc17b8aafed74881c35"&gt;Cy_BLE_GATTC_SendConfirmation()&lt;/a&gt;.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Improve usability  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;The BLE Stack was updated to version 5.0.0.855. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Refer to &lt;a href="#page_group_ble_changelog_1section_group_ble_changelog_BLE_Stack_Changes"&gt;BLE Stack Changes&lt;/a&gt;. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="4"&gt;&lt;p&gt;2.0 &lt;br /&gt; BETA#1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Renamed API: &lt;br /&gt; Cy_BLE_GAP_UpdateAdvScanData() to &lt;a href="group__group__ble__common__api__gap__peripheral__functions.html#group__group__ble__common__api__gap__peripheral__functions_1gabb8ab6894ec553068f75d5f81a95aeda"&gt;Cy_BLE_GAPP_UpdateAdvScanData()&lt;/a&gt;; &lt;br /&gt; Cy_BLE_SetConnectionPriority() to &lt;a href="group__group__ble__common__api__gap__functions.html#group__group__ble__common__api__gap__functions_1gae11049cc1da0686a4393e7db503ee282"&gt;Cy_BLE_GAP_SetConnectionPriority()&lt;/a&gt;. &lt;br /&gt;  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Consistent API naming scheme  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Made the maximum number of connections configurable. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;SRAM consumption reducing when extra connections are not used.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added new options for the CPU Core parameter. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Support of single-core devices.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;The BLE Stack was updated to version 5.0.0.785. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Refer to &lt;a href="#page_group_ble_changelog_1section_group_ble_changelog_BLE_Stack_Changes"&gt;BLE Stack Changes&lt;/a&gt;. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial version. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">BLE Stack Changes</heading></para>
<para>This section lists changes made to the BLE Stack.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;&lt;b&gt;Version&lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;&lt;b&gt;Changes&lt;/b&gt;&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;&lt;b&gt;Reason for Change&lt;/b&gt;&lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="3"&gt;&lt;p&gt;5.0.8.220 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated BLE ISR for SoC mode. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Enhanced the BLE ISR to handle LL Channel Map in interrupt context for SoC mode.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated low-power mode API. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated Cy_BLE_ControllerEnterLPM API for handling a scenario where wake-up is initiated by the hardware.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Re-factored Shutdown code for Dual CPU mode. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Improved the handling of Cy_BLE_StackShutdown API to avoid timing-sensitive bugs. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="3"&gt;&lt;p&gt;5.0.7.196 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated the APIs to handle the interrupt locking. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A better locking mechanism to avoid potential timing-sensitive bugs.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Re-factored the radio initialization sequence. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;It was observed that on customer boards, re-factoring the radio initialization sequence provided an improved stability to the reset sequence.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Fix for CVE-2019-16336. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Enforced the length check on incoming LL PDUs to protect against buffer overflows caused by malicious packets. Malformed Data packets will be dropped in the LL. Malformed Control packets will be replied with LL_UNKNOWN_RSP. For detail, refer to the &lt;a href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-16336"&gt;CVE-2019-16336&lt;/a&gt; vulnerability page.  &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="3"&gt;&lt;p&gt;5.0.6.161 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated the radio configuration. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;To support the new packages: QFN68 and BGA124.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added checks for Malformed LL PDUs. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;LL PDUs with the incorrect length must be replied with LL_UNKNOWN_RSP per latest BLE spec. Also, this prevents against any unknown behavior triggered due to malicious LL PDUs.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Documentation update. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated the documentation for the CY_BLE_EVT_RADIO_TEMPERATURE and CY_BLE_EVT_RADIO_VOLTAGE_LEVEL events. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="7"&gt;&lt;p&gt;5.0.5.110 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Optimized the ACL TX path for a better throughput. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The throughput was observed to be low when the stack libraries were linked with MDK libraries.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added support for autonomous feature exchange on connection complete. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Few mobile phone (eg. Droid Turbo) negotiate DLE with TX octets &amp;gt; 27 bytes but do not actually support the DLE feature. This leads to interoperability issues with such phones. An autonomous feature exchange will be triggered when the PSoC 6 device is in master role, and the DLE and PHY update negotiations will be triggered only if the peer supports DLE/PHY update feature. In case PSoC 6 is in a slave role, DLE/PHY update negotiations will not be triggered till the peer initiates a feature exchange procedure and hence exchanges it's feature set.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added support for configurable PA LDO settings. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;It was observed that on customer boards, the output RF TX power was sub-optimal, when the factory settings for PA LDO were used. To fine tune the PA LDO settings at the customer end, the same were now exposed via the paCalConfig member of stackConfig input structure to the Cy_BLE_StackInit API.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated RSSI formula. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;With the previous formula, there existed a non-linearity in the measured value of RSSI at ~ -50dBm.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;The SoC mode library was split into three libraries: host, controller and stack manager. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The new organization structure allows usage of the same controller library with BLESS host, a UART application or any third party host, over a software HCI interface.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Fixed issue with disconnection. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;If an LL procedure is on-going, and a disconnect command is issued, the Terminate PDU is not transmitted over the air even after the procedure completes.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated Cy_BLE_StackInit API to check that if DLE is disabled, max TX and RX octets must be set to 27 Bytes. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The check for the DLE parameters was not correct for the case when DLE is disabled. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="4"&gt;&lt;p&gt;5.0.4.946 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Fix for CVE-2019-17061. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated the handling of LL PDU with LLID 0 to prevent corruption in subsequently received LL PDUs. Such packets will be dropped in the LL, but the peer will be acked for the packet. For detail, refer to the &lt;a href="https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2019-17061"&gt;CVE-2019-17061&lt;/a&gt; vulnerability page.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Enabled the RSSI reading after the CRC has been received. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The RSSI value was not being updated if deep sleep was enabled in the controller.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Optimized the ACL TX path for a better throughput. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;In BLE dual CPU mode, with CM0p running at 25 MHz, the BLE throughput was observed to be sub-optimal.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added support for the PDL APIs to calculate temperature and Battery monitor output. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;New APIs were added to the PDL to calculate the absolute values of the die temperature and radio voltage, using the raw values from the radio. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="4"&gt;&lt;p&gt;5.0.3.935 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;1.Added the option to override the paCal table and LoBuff table from the application.&lt;br /&gt; 2.Added the option to set lobuflimit and calvallimit from the application.&lt;br /&gt; 3.Updated the PA LDO settings to use the settings recommended by the designers.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Additional flexibility is provided to obtain an optimal output power at the user's board.&lt;br /&gt; The new PA LDO setting recommended by the designers results in the ~ 1dBm higher output power (measured using Cypress 001 kits) at the 4dBm setting.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;The local SCA with PILO is enabled to be set to 500 ppm. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The PILO frequency accuracy is of the order of 500 ppm.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;The BLE SMP pairing vulnerability fix:&lt;br /&gt; 1.Added the public key validation check for the remote key.&lt;br /&gt; 2.Updated the documentation for the &lt;a href="group__group__ble__common__api__gap__functions.html#group__group__ble__common__api__gap__functions_1gaf79df714437d3fc58fc653641fafd80a"&gt;Cy_BLE_GAP_GenerateSetLocalP256Keys()&lt;/a&gt; API, to recommend the application to update the private key as mentioned in the BLE Core spec 5.0 Vol. 3 Part H, Section 2.3.6.&lt;br /&gt; 3.Added the feature bit mask for the remote public key validation.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The update to comply with BLE Core Specification Errata 10734.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.When none of the BLE hardware engines are active, disable the hardware auto wakeup feature before entering deep sleep mode.&lt;br /&gt; 2.Re-enable the hardware auto wakeup feature before entering deep sleep if any of the BLE hardware blocks are active.&lt;br /&gt;&lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The fix for a spurious interrupt triggered by the link layer hardware when the firmware continuously enters/exits deep sleep mode. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="3"&gt;&lt;p&gt;5.0.2.917 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added a new BLE event - CY_BLE_EVT_GAP_ADV_TX, which is triggered on transmission of an ADV packet (if this feature is enabled).  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Support for BLE mesh.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Dual CPU mode: Stack Shutdown sequence modified to shut down controller before sending CY_BLE_EVT_STACK_SHUTDOWN_COMPLETE event.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The controller was shut-down after informing the application that shutdown had been completed.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the Cy_BLE_HAL_BlessInterruptHandler API to return status.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;This return parameter indicates that user should call &lt;a href="group__group__ble__common__api__functions.html#group__group__ble__common__api__functions_1ga0f1982f915c28b0d5a317442bec9eafc"&gt;Cy_BLE_ProcessEvents()&lt;/a&gt; to process pending BLE Stack events. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="4"&gt;&lt;p&gt;5.0.1.906 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added check for any pending real time procedures before allowing autonomous PHY update request.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Autonomous PHY update request was being initiated without a check for "LL control procedure collision".   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Fixed memory allocation failure issue observed when initializing buffer pool for ACL Rx Packet.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Memory allocation failure was observed when DLE Rx Octet &amp;lt; TxOctet.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added support to disconnect LE link whenever there is real-time LL procedure collision.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Consistent with BLE Spec 5.0 erratum 7106  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added support for PILO.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;PSoC 6 BLE supports a Precision ILO which can be used as an LF clock source instead of the WCO.  &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;5.0.0.898 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Enhancement is done to rerun the scheduler on close CE, if the event about to be scheduled is in past.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Blocking flash write operation blocks the CPU from executing any interrupts (including BLESS isr) for &amp;gt; 17ms, Due to this, if the CI for connection is smaller than 17ms, the BLE link will disconnect.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;The calibration target value for the Max output power level is modified under the user-defined condition. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The enhancement to support the 5dBm Tx power in the BLE stack. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="3"&gt;&lt;p&gt;5.0.0.855 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Changed the input parameter for the &lt;a href="group__group__ble__common__api__functions.html#group__group__ble__common__api__functions_1gad55cb28342cfcbbf87c4e466ac4aa08b"&gt;Cy_BLE_SetCustomEventMask()&lt;/a&gt; API from (uint8* mask) to (uint32 mask). &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Consistent with the bit mask scheme.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.The timer context was never reset, it is made to reset during the Stack shutdown. &lt;br /&gt; 2.The timer context was not freed even when the timer start failed. It is made free when the timer start fails due to any reason.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The &lt;a href="group__group__ble__common__api__gap__central__functions.html#group__group__ble__common__api__gap__central__functions_1gaf05df8db69912fcab86883b2618eb66e"&gt;Cy_BLE_GAPC_StopScan()&lt;/a&gt; function returns CY_BLE_ERROR_MAX when the &lt;a href="group__group__ble__common__api__gap__central__functions.html#group__group__ble__common__api__gap__central__functions_1gaf05df8db69912fcab86883b2618eb66e"&gt;Cy_BLE_GAPC_StopScan()&lt;/a&gt; function is called to stop a previously-initiated scanning procedure. This issue occurs only when the authentication procedure is occurring and the application tries to stop the scan   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.The DLE control procedure timer is started only if the queuing Data Length Request in the Hardware FIFO is successful.&lt;br /&gt; 2.Added checks to handle the race condition between the ACK processing and Handling data PDU's from the Host.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Unexpected disconnection due to an LMP Response timeout in the embedded stress application. This issue is due to:&lt;br /&gt; 1.The DLE control procedure timer was started even if the sending Data Length Request PDU failed when queuing it in the Hardware FIFO.&lt;br /&gt; 2.Due to the race condition between the ACK processing and Handling data PDU's from the Host.  &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;5.0.0.785 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial BLE Stack version.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>